<template>
  <div class="tenant">
    <!-- <Banner /> -->
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        highlight-current-row
        :selectConfig="selectConfig"
        :table-events="{
          //element talbe事件都能传
          select: select,
        }"
        :action-list="[
          {
            text: '添加设备',
            action: () => openModal('add'),
          },
        ]"
        @get-list="getList"
      >
        <template #slotName="{ item }">
          {{ item.createTime }}
        </template>
      </byTable>
    </div>
    <el-dialog
      :title="modalType == 'add' ? '添加设备' : '编辑'"
      v-model="dialogVisible"
      width="800"
      v-loading="loading"
    >
      <byForm
        :formConfig="formConfig"
        :formOption="formOption"
        v-model="formData.data"
        :rules="rules"
        ref="byform"
      >
      </byForm>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button
          type="primary"
          @click="submitForm('byform')"
          size="large"
          :loading="submitLoading"
        >
          确 定
        </el-button>
      </template>
    </el-dialog>
  </div>
</template>
  
<script setup>
/* eslint-disable vue/no-unused-components */
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import { computed, defineComponent, ref } from "vue";
const loading = ref(false);
const submitLoading = ref(false);
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
  },
});
let dialogVisible = ref(false);
let roomDialogVisible = ref(false);
let modalType = ref("add");
let rules = ref({
  tdaProductId: [
    { required: true, message: "请选择行业名称", trigger: ["blur", "change"] },
  ],
  productId: [
    { required: true, message: "请选择产品名称", trigger: ["blur", "change"] },
  ],
  deviceName: [
    { required: true, message: "请输入设备名称", trigger: ["blur", "change"] },
  ],
  nodeId: [
    { required: true, message: "请输入设备标识", trigger: ["blur", "change"] },
  ],
  secret: [
    { required: true, message: "请输入密钥", trigger: ["blur", "change"] },
  ],
});
const { proxy } = getCurrentInstance();
const selectConfig = reactive([
  {
    label: "行业名称",
    prop: "flowStatus",
    data: [],
  },
  {
    label: "产品名称",
    prop: "flowStatus",
    data: [],
  },
]);

const config = computed(() => {
  return [
    {
      attrs: {
        label: "行业名称",
        prop: "appName",
      },
    },
    {
      attrs: {
        label: "产品名称",
        prop: "productName",
        align: "center",
      },
    },
    {
      attrs: {
        label: "设备名称",
        prop: "deviceName",
        align: "center",
      },
    },
    {
      attrs: {
        label: "设备标识",
        prop: "nodeId",
        align: "center",
      },
    },
    {
      attrs: {
        label: "密钥",
        prop: "secret",
        align: "center",
      },
    },
    {
      attrs: {
        label: "操作",
        width: "200",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "删除",
              type: "danger",
              text: true,
            },
            el: "button",
            click() {
              // 弹窗提示是否删除
              ElMessageBox.confirm(
                "此操作将永久删除该数据, 是否继续?",
                "提示",
                {
                  confirmButtonText: "确定",
                  cancelButtonText: "取消",
                  type: "warning",
                }
              ).then(() => {
                // 删除
                proxy
                  .post("/tdaDevice/delete", {
                    id: row.id,
                  })
                  .then((res) => {
                    ElMessage({
                      message: "删除成功",
                      type: "success",
                    });
                    getList();
                  });
              });
            },
          },
        ];
      },
    },
  ];
});

let formData = reactive({
  data: {},
  treeData: [],
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const treeData = ref([]);
const formConfig = reactive([
  {
    type: "select",
    prop: "copyTdaProductId",
    label: "行业名称",
    required: true,
    // isLoad: {
    //   url: "/tdaApplication/page",
    //   req: {
    //     pageNum: 1,
    //     pageSize: 9999,
    //   },
    //   labelKey: "appName",
    //   labelVal: "id",
    //   method: "post",
    //   resUrl: "rows",
    // },
  },
  {
    type: "select",
    prop: "tdaProductId",
    label: "产品名称",
    required: true,
    data: [],
  },
  //  isLoad: {
  //   url: "/tdaProduct/page",
  //   req: {
  //     pageNum: 1,
  //     pageSize: 9999,
  //   },
  //   labelKey: "name",
  //   labelVal: "id",
  //   method: "post",
  //   resUrl: "rows",
  // },
  {
    type: "input",
    prop: "deviceName",
    label: "设备名称",
    required: true,
  },
  {
    type: "input",
    prop: "nodeId",
    label: "设备标识",
    required: true,
  },
  {
    type: "input",
    prop: "secret",
    label: "密钥",
    required: true,
  },
]);
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy.post("/tdaDevice/page", sourceList.value.pagination).then((message) => {
    console.log(message);
    sourceList.value.data = message.rows;
    sourceList.value.pagination.total = message.total;
    setTimeout(() => {
      loading.value = false;
    }, 200);
  });
};
const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formData.data = {};
};
const selection = ref({
  data: [],
});
const select = (_selection, row) => {
  selection.value.data = _selection;
  console.log(_selection.length);
};
const openRoomModal = () => {
  roomDialogVisible.value = true;

  proxy
    .get("/tenantInfo/roleMenuTreeSelect/" + selection.value.data[0].tenantId)
    .then((res) => {
      if (res.code == 200) {
        treeData.value = res.menus;
        formData.treeData = res.checkedKeys;
        tree.value.setCheckedKeys(res.checkedKeys);
      }
    });
};
const tree = ref(null);
const submitTree = () => {
  proxy
    .post("/tenantInfo/bindingMenu", {
      tenantId: selection.value.data[0].tenantId,
      menuIdList: tree.value.getCheckedKeys(),
    })
    .then((res) => {
      ElMessage({
        message: "保存成功",
        type: "success",
      });
      roomDialogVisible.value = false;
    });
};

const submitForm = () => {
  console.log(byform.value);
  byform.value.handleSubmit((valid) => {
    submitLoading.value = true;
    proxy.post("/tdaDevice/" + modalType.value, formData.data).then(
      (res) => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;
        getList();
      },
      (err) => (submitLoading.value = false)
    );
  });
};

const getDtl = (row) => {
  modalType.value = "edit";

  proxy.post("/tdaDevice/detail", { id: row.id }).then((res) => {
    formData.data = res;
    console.log(formData);
    dialogVisible.value = true;
  });
};

const selectData = reactive({
  tradeList: [],
});
const getSelect = () => {
  proxy
    .post("/tdaApplication/page", { pageNum: 1, pageSize: 9999 })
    .then((message) => {
      selectData.tradeList = message.rows;
      formConfig[0].data = selectData.tradeList.map((x) => ({
        title: x.appName,
        value: x.id,
      }));
      // formConfig[1].data = selectData.tradeList.map((x) => ({
      //   title: x.name,
      //   value: x.id,
      // }));
    });
};

watch(
  () => formData.data.copyTdaProductId,
  (val, old) => {
    if (val) {
      proxy
        .post("/tdaProduct/page", {
          pageNum: 1,
          pageSize: 9999,
          tdaApplicationId: val,
        })
        .then((res) => {
          formConfig[1].data = res.rows.map((x) => ({
            title: x.name,
            value: x.id,
          }));
        });
    }
  }
);
getList();
getSelect();
</script>
  
<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
</style>